<?php
/**
 * Plugin Name: The Events Calendar: Additional iCal Export options
 * Description: Adds more options for the iCal export capability in The Events Calendar.
 * Version: 2016-07-05
 * Author: Modern Tribe, Inc.
 * Author URI: http://m.tri.be/1x
 * License: GPLv2 or later
 */
defined( 'WPINC' ) or die;

// The snippet framework files
require_once dirname( __FILE__ ) . '/tribe-snippet-framework/src/Tribe/Snippet.php';
require_once dirname( __FILE__ ) . '/tribe-snippet-framework/src/Tribe/Settings_Helper.php';
require_once dirname( __FILE__ ) . '/tribe-snippet-framework/src/Tribe/View_Helper.php';
require_once dirname( __FILE__ ) . '/tribe-snippet-framework/src/functions/general.php';


Class Tribe__Snippet__Ical_Export_Options extends Tribe__Snippet {

	protected $plugins_required = array(
		'The Events Calendar',
	);

	protected $snippet_file = __FILE__;

	public function snippet_init() {
		add_action( 'pre_get_posts', array( $this, 'filter_ical_query' ), 100 );
	}


	public function filter_ical_query( $query ) {
		if ( ! isset( $_GET['ical'] ) || ! isset( $query->tribe_is_event_query ) || ! $query->tribe_is_event_query ) return;

		$tribe_display = $_GET[ 'tribe_display' ];

		if( $tribe_display === 'year' ) {
			$start_of_year = date( 'Y' ) . '-01-01';
			$end_of_year = date( 'Y' ) . '-12-31';

			$query->set( 'eventDisplay', 'custom' );
			$query->set( 'start_date', $start_of_year );
			$query->set( 'end_date', $end_of_year );
			$query->set( 'posts_per_page', - 1 );
		}

		elseif ( $tribe_display === 'recently-published' ) {
			$query->set( 'order', 'DESC' );
			$query->set( 'orderby', 'modified' );
			$query->set( 'posts_per_page', tribe_get_option( 'postsPerPage', 20 ) );

			// Remove default oderby and wheres, lest they return events sorted by event_date
			remove_filter( 'posts_orderby', array( 'Tribe__Events__Query', 'posts_orderby' ), 10, 2 );
			remove_filter( 'posts_where', array( 'Tribe__Events__Query', 'posts_where' ), 10, 2 );
		}

	}


}

new Tribe__Snippet__Ical_Export_Options();